#ifndef ACT_ROOT
#define ACT_ROOT
#include "controller/controller.h"
#include "allocate/factory.h"
class root_controller_t : public controller_t {
	public:
	class configuration_t {
		private:
		mode_t mode_m;
		public:
		configuration_t(mode_t mode_p);
	};
	controller_t::status_t on_event(event_t event_p) override;
	private:
	root_controller_t(configuration_t configuration_p);
	friend class root_controller_factory_t;
};
class root_controller_factory_t : public factory_t<root_controller_t::configuration_t, root_controller_t> {
	public:
	root_controller_t create(root_controller_t::configuration_t configuration_p) override;
};
#endif
